-- Some handy functions for standalone work

DEFAULT_CHAT_FRAME = {
   AddMessage = function(self, msg) 
		   io.write(msg .. "\n");
		end
};

local func, err = loadfile("./StatRingsScaffold.lua");
if (err) then
   io.write("Failed to load: " .. err .. "\n");
   return;
end
func();

io.write("Creating new compiler...\n");
compiler = StatRingsScaffoldCompiler_Run(StatRings_NewScaffoldSpec);
io.write("Done.\n");

for k,v in pairs(compiler.anchors) do
   local msg = "";
   if (v.derived) then
      msg = msg .. " (derived by " .. v.derived .. ")";
   end
   if (v.inactive) then
      msg = msg .. " (inactive)";
   end
   io.write(" Anchor " .. k .. ":" .. msg .. "\n");
end
for _,n in ipairs(compiler.scan) do
   io.write(" [" .. _ .. "] " .. n .. "\n");
end

io.write("Now testing scaffold as a whole...\n");
scaffold = StatRingsScaffold_New();
success, errors = scaffold:Compile(StatRings_NewScaffoldSpec);

if (not success) then
   io.write("FAILED TO COMPILE SCAFFOLD!\n");
   for _, e in ipairs(errors) do
      io.write("  !! " .. e .. "\n");
   end
   return;
end

io.write("Scaffold compilation complete.\n");
scaffold:Dump(true);
io.write("Updating scaffold.\n");
scaffold:Update();
scaffold:Dump(true);
